// ============================================================
//  BouncingBall.h	1996 Hiroshi Lockheimer
// ============================================================

#pragma once


#pragma export on


extern "C" {

extern void	module_initialize(void *inSettings, long inSettingsSize);
extern void	module_cleanup(void **outSettings, long *outSettingsSize);
extern void	module_start_saving(BView *inView);
extern void	module_stop_saving();
extern void module_start_config(BView *inView);
extern void module_stop_config();

}


#pragma export reset


#include "CSaveThread.h"


class CBouncingBallThread : CSaveThread {
public:
					CBouncingBallThread();
					
	virtual void	StartSaving(BView *view);
	virtual void	StopSaving();

protected:
	virtual double	Save();
	
protected:
	BList			mBallList;
};


class CBouncingBall {
public:
					CBouncingBall(BView *inView);
	
	void			NextStep();
	
protected:
	BRect			mBallRect;		// the rectangle defining the ball
	BRect			mOldRect;		// previos ball rect
	float			mBallDiameter;	// diameter of ball
	double			mBallAngle;		// angle ball is traveling in
	double			mBallSin;		// sin of angle of ball
	double			mBallCos;		// cos of angle of ball
	short			mXDir;			// sign of x-component of velocity
	short			mYDir;			// sign of y-component of velocity
	long			mBounceCount;	// when to choose a new bounce
	rgb_color		mBallColor;		// the color of the ball
	BView*			mView;			// saver's view
	BWindow*		mWindow;		// mView's window
};


short		RangedRandom(short lower, short upper);
double		RandomAngle(short lower, short upper);